<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Delete student</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body>
    <div class="container w-50">
        <div class="text-center m-3">
            <h3>XÓA THÔNG TIN SINH VIÊN</h3>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="input-student-id">Nhập Id sinh viên <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-4">
                <input id="input-student-id" placeholder="Nhập id sinh viên ..." class="form-control">
            </div>
            <div class="col-sm-4">
                <button class="btn btn-primary" onclick="onBtnKiemTraClick()">Kiểm tra</button>
                <button id="btn-delete-student" class="btn btn-danger disable" disabled onclick="onBtnDeleteClick()">Xóa SV</button>
            </div>
        </div>
        <hr>
        <div class="row form-group">
            <label class="col-form-label col-sm-12" id="lbl-status">Trạng thái</label>
        </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    //base URL
    const gBASE_URL = "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/";
    var gStudentID = "";
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
   //hàm xử lý khi nhấn nút xoá
   function onBtnDeleteClick() {
      "use strict";
      //b1 - thu thập
      //đã lưu id vào biến toàn cục gStudentID khi lấy kiểm tra sinh viên
      //b2 - kiểm tra
      var vKiemTraDuLieuDung = validateData(gStudentID);
        if (vKiemTraDuLieuDung) {
        //b3 - gửi request api xoá thông sinh viên bằng id
        //biến khởi tạo request
        var vXmlHttp = new XMLHttpRequest();
        deleteStudentById(vXmlHttp, gStudentID);
        //b4 - xử lý response, hiển thị thông tin sau khi xoá
        vXmlHttp.onreadystatechange = function () {
          // xóa thành công student
          if (
            this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            this.status == gREQUEST_STATUS_OK
          ) {
            alert("Đã xoá sinh viên có id là " + gStudentID + " thành công!");
            console.log("Delete student " + gStudentID + " success!");
          }
        };
      }
    }
   
    function onBtnKiemTraClick() {
        "use strict";
        // Bước 1: thu thập dữ liệu
        gStudentID = readDataStudent();
        // Bước 2: validate dâta
        var vKiemTraDuLieuDung = validateData(gStudentID);
        if (vKiemTraDuLieuDung) {
            //Bước 3: Gọi API
            //create request
            var vXmlHttp = new XMLHttpRequest();
            callApiStudentById(vXmlHttp, gStudentID);
            // Bước 4: Xử lý response, hiển thị thông tin sv tìm thấy
            receiveResponse(vXmlHttp);
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // API lấy chi tiết 01 sinh viên by id
    function callApiStudentById(paramXmlHttpRequest, paramObjectStudent) {
        const vAPI_URL = gBASE_URL + "/students/" + paramObjectStudent;
        paramXmlHttpRequest.open("GET", vAPI_URL, false);
        paramXmlHttpRequest.send();
    }
    //hàm xoá sinh viên thông qua id
    function deleteStudentById(paramXML, paramId) {
      var vUrl = gBASE_URL + "students/" + paramId;
      paramXML.open("DELETE", vUrl, true);
      paramXML.send();
    }

    //hàm xử lý thông tin khi nhận response phản hồi
    function receiveResponse(paramXML) {
        //truy xuất khung trạng thái thông qua id
      var vStatusLabel = document.getElementById("lbl-status");
      // nhận về response và xử lý
      var vStatusCode = paramXML.status;
      // nếu trạng thái trả về thành công!
      if (vStatusCode == gREQUEST_STATUS_OK) {
        // nhận lại response dạng JSON ở xmlHttp.responseText và chuyển thành object
        var bResponse = JSON.parse(paramXML.responseText);
        //hiển thị thông tin sinh viên lên vùng trạng thái
        vStatusLabel.innerHTML = `Thông tin sinh Viên có id là ${bResponse.id}: <br>
                    Student code: ${bResponse.studentCode}<br>
                    Username: ${bResponse.username}<br>
                    First name: ${bResponse.firstname}<br>
                    Last name: ${bResponse.lastname}<br>
                    Birthday: ${bResponse.birthday}<br>
                    Email: ${bResponse.email}<br>
                    Study year: ${bResponse.studyYear}<br>`;
        //truy xuất nút xoá sv qua id
        var vDeletaButton = document.getElementById("btn-delete-student");
        vDeletaButton.disabled = false;
      } else {
        //hiển thị thông tin sinh viên lên vùng trạng thái
        vStatusLabel.innerHTML = "Không tồn tại Sinh viên với id đã nhập";
      }
    }

    // Bước 1: thu thập dữ liệu
    function readDataStudent(paramObjectStudent) {
        "use strict";
        var vIdElement = document.getElementById("input-student-id");
        var vId = vIdElement.value.trim();
        return vId;
    }

    // hàm validate (bước 2)
    function validateData(paramId) {
        "use strict";
        if (paramId.length == 0) {
        alert("Phải nhập ID sinh viên !!!");
        return false;
      } else if (isNaN(paramId)) {
        alert("ID phải là số !!!");
        return false;
      }
      return true;
    }

</script>

</html>